QuotientRing< T > Class Template Reference

Quotient Ring. More...

`#include <algebra.h>`

Inheritance diagram for QuotientRing< T >:

## Public Types

typedef T | EuclideanDomain
typedef T::Element | Element

## Public Member Functions

| QuotientRing (const EuclideanDomain &domain, const Element &modulus)
const EuclideanDomain & | GetDomain () const
const Element & | GetModulus () const
bool | Equal (const Element &a, const Element &b) const
const Element & | Identity () const
const Element & | Add (const Element &a, const Element &b) const
Element & | Accumulate (Element &a, const Element &b) const
const Element & | Inverse (const Element &a) const
const Element & | Subtract (const Element &a, const Element &b) const
Element & | Reduce (Element &a, const Element &b) const
const Element & | Double (const Element &a) const
bool | IsUnit (const Element &a) const
const Element & | MultiplicativeIdentity () const
const Element & | Multiply (const Element &a, const Element &b) const
const Element & | Square (const Element &a) const
const Element & | MultiplicativeInverse (const Element &a) const
bool | operator== (const QuotientRing< T > &rhs) const
virtual const Element & | Divide (const Element &a, const Element &b) const
virtual Element | Exponentiate (const Element &a, const Integer &e) const
virtual Element | CascadeExponentiate (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
virtual const AbstractGroup< T > & | MultiplicativeGroup () const
virtual bool | InversionIsFast () const
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const

## Protected Attributes

EuclideanDomain | m_domain
Element | m_modulus

## Detailed Description

### template<class T>
class QuotientRing< T >

Quotient Ring.

Definition at line 218 of file algebra.h.

The documentation for this class was generated from the following file:

- algebra.h